 /**
 * file: MainMenu.java
 *
 * last edited: Sanjay Patil 01/10/2006
 */

// import necessary java libraries
//
import java.awt.*;
import javax.swing.*;
import java.awt.event.ActionListener;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.*;

/**
 *
 * implement the menu driven system that drives the applet
 *
 * hierarchy: JPanel->SubPanel->MainMenu
 *
 */
public class MainMenu extends SubPanel implements ActionListener
{

    // *********************************************************************
    //
    // declare global variables and components
    //
    // *********************************************************************

    // declare the menu font layout
    //
    Font currentFont = getFont();
    Font newFont = new Font(currentFont.getName(), currentFont.getStyle(), 12);

    // declare the menu layout
    //
    JMenuBar menuBar;
    JMenu menu;
    JMenuItem menuItem;
    JMenuItem algoParamMenuItem;
    JMenuItem prevMenuItem;
    JMenuItem nextMenuItem;
    JCheckBoxMenuItem nearestMenuItem;
    JCheckBoxMenuItem euclideanMenuItem;
    JCheckBoxMenuItem pcaMenuItem;
    JCheckBoxMenuItem pca1MenuItem;
    JCheckBoxMenuItem ldaMenuItem;
    JCheckBoxMenuItem lda1MenuItem;
    JCheckBoxMenuItem ldapcaMenuItem;       //I add here for lpa->pca 1
    JCheckBoxMenuItem ldapca1MenuItem;
    // Tao
    JCheckBoxMenuItem hldaMenuItem;

    JCheckBoxMenuItem icaMenuItem;
    JCheckBoxMenuItem ica1MenuItem;
    JCheckBoxMenuItem svmMenuItem;
    JCheckBoxMenuItem svm1MenuItem;
    JCheckBoxMenuItem lpMenuItem;       //I add here for lp and particle
    JCheckBoxMenuItem pfMenuItem;
    JCheckBoxMenuItem kfMenuItem;
    JCheckBoxMenuItem ukfMenuItem;
    JRadioButtonMenuItem rbMenuItem;

    // declare components for the help box
    //
    JFrame frame;
    JTextArea textArea;
    JScrollPane scrollPane;
    JButton dismiss;

    // declare components for the scales frame
    //
    JFrame scale;
    JButton change;

    // declare components for the gaussian frame
    //
    JFrame setgausdlg;
    JButton applyb;
    JButton cancel;

    // declare components for the color selection frame
    //
    JFrame setccolorsdlg;
    JLabel colorselection;
    JLabel dset1color;
    JLabel dset2color;
    JLabel dset3color;
    JLabel dset4color;
    JButton setdset1;
    JButton setdset2;
    JButton setdset3;
    JButton setdset4;
    JButton setcolors;  
    JPanel paneldset1 = new JPanel();
    JPanel paneldset2 = new JPanel();
    JPanel paneldset3 = new JPanel();
    JPanel paneldset4 = new JPanel();  

    // declare components for the algorithm param dialogs
    //
    // kmeans
    //
    JFrame setkmeansdlg;
    JLabel kmeansparamlbl;
    JLabel kmeansIterLbl; 
    JTextField kmeansIterFld; 
    JLabel kmeansClustersLbl; 
    JTextField kmeansClustersFld; 
    JButton applykmeansparamsbttn;

    // LBG
    //
    JFrame setlbgdlg;
    JButton applylbgparamsbttn;

    // HLDA
    //
    JFrame sethldadlg;
    JLabel hldaparamlbl;
    JButton applyhldaparamsbttn;

    // LP
    //
    JFrame setlpdlg;
    JLabel lpparamlbl;
    JButton applylpparamsbttn;

    // KF
    //
    JFrame setkfdlg;
    JLabel kfparamlbl;
    JButton applykfparamsbttn;

    // UKF
    // 
    JFrame setukfdlg;
    JLabel ukfparamlbl;
    JButton applyukfparamsbttn;

    // PF
    //
    JFrame setpfdlg;
    JLabel pfparamlbl;
    JButton applypfparamsbttn;

    // declare components for the k-mean algorithm
    //
    JFrame clusterpara;
    JButton initcluster;

    // declare components for the LBG algorithm
    //
    JFrame iterpara;
    JButton inititer;

    // declare components for the LP algorithm
    //
    JFrame lpsetorderpara;
    JButton initlporder;
    
    // declare componets for setting interpolation order in the LP algorithm 
    //
    JFrame ipsetorderpara;
    JButton initiporder;

    // declare components for the Kalman Filter (KF) algorithm
    //
    JFrame setobsFrame;
    JButton initobs;
    
    // declare components for the Kalman Filter (KF) algorithm
    //
    JFrame settrnFrame;
    JButton inittrn;
    
    // declare components for the Kalman Filter (KF) algorithm
    //
    JFrame setcovar_nse_proFrame;
    JButton initcovar_nse_pro;

    // declare components for the Kalman Filter (KF) algorithm
    //
    JFrame setcovar_nse_obsFrame;
    JButton initcovar_nse_obs;
     
    // declare components for the Kalman Filter (KF) algorithm
    //
    JFrame setcovar_nse_errFrame;
    JButton initcovar_nse_err;
     
    // declare components for the particle filter algorithm
    //
    JFrame set_pf_covar_nse_proFrame;
    JButton init_pf_covar_nse_pro;
    
    // declare components for the particle algorithm
    //
    JFrame set_pf_covar_nse_obs_frame;
    JButton init_pf_covar_nse_obs;
    
    // declare components for the particle algorithm
    //
    JFrame setparticlesFrame;
    JButton initparticles;


    // declare components for the HLDA algorithm
    // Covariance Type
    // Tao
    JFrame setcovtypeFrame;
    JButton initcovtype;

    // declare components for the HLDA algorithm
    // init Type
    // Tao
    JFrame sethlda_initypeFrame;
    JButton inithlda_initype;

    
    // declare components for the unscented Kalman Filter (UKF) algorithm
    //
    JFrame setalphaFrame;
    JButton initalpha;
    
    // declare components for the unscented Kalman Filter (UKF) algorithm
    //
    JFrame setbetaFrame;
    JButton initbeta;
    
    // declare components for the unscented Kalman Filter (UKF) algorithm
    //
    JFrame setkappaFrame;
    JButton initkappa;

    // global variables for the k-means algorithm
    //
    int guesses = 4;
    int iterations = 4;

    // global variables for the LBG algorithm
    //
    int clusters = 8;

    // global variables for setting linear and interpolation order in 
    // the LP algorithm 
    // used with LP, KF, UKF, and PF algorithm
    //
    int lporder = 3;
    int iporder = 10;

    // KF, UKF, and PF
    //
    double obs = 1.0;
    double trn = 1.5;

    // KF, UKF, and PF
    //
    int particles = 50;

    // KF, UKF, and PF
    //
    double covar_nse_pro  = 0.03;
    double covar_nse_obs  = 0.024;
    double covar_nse_err  = 0.001;
    
    // HLDA
    // Tao
    int covtype = 1;
    int hlda_initype = 1;


    // unscented Kalman Filter
    //
    double alpha = 0.001;
    double beta =  2.0;
    double kappa = 0.0;

    // flags
    //
    boolean drwptsf = true;
    boolean drwgaussf = false;
    boolean zoomi = false;
    boolean zoomo = false;  


    // global variable for the gaussian distribution
    //
    int points = 25;
    double meanx = 0.0;
    double meany = 0.0;
    double cov11 = 0.05;
    double cov12 = 0.0;
    double cov21 = 0.0;
    double cov22 = 0.05;

    // declare varaibles to read the help file
    //
    URL url;
    Vector urlvec;
    String document;
    BufferedReader buff;
    AppletContext context;

    // declare components for the time scales
    //
    JLabel xMinLabel; // x-axis minimum label
    JLabel xMaxLabel; // x-axis maximum label
    JLabel yMinLabel; // y-axis minimum label
    JLabel yMaxLabel; // y-axis maximum label

    JTextField xMinField; // x-axis minimum text field
    JTextField xMaxField; // x-axis maximum text field
    JTextField yMinField; // y-axis minimum text field
    JTextField yMaxField; // y-axis maximum text field

    // declare components for the gaussian distribution
    //
    JLabel pointsLabel; // max points in distribution label
    JLabel meanxLabel; // mean of distribution (x) label
    JLabel meanyLabel; // mean of distribution (y) label
    JLabel setgausLabel; //Gaussian Settings Label  
    JLabel covLabel;  //Covariance Lable
    JLabel cov11Label; // covariance c11 of distribution label
    JLabel cov12Label; // covariance c12 of distribution label
    JLabel cov21Label; // covariance c21 of distribution label
    JLabel cov22Label; // covariance c22 of distribution label

    JTextField pointsField; // max points in distribution text field
    JTextField meanxField; // mean of distribution (x) text field
    JTextField meanyField; // mean of distribution (y) text field
    JTextField cov11Field; // covariance c11 text field
    JTextField cov12Field; // covariance c12 text field
    JTextField cov21Field; // covariance c21 text field
    JTextField cov22Field; // covariance c22 text field

    // declare components for the k-means algorithm
    //

    JLabel iterationsLabel; // max number of iterations label   
    JLabel clusterLabel; // max number of clusters

    JTextField iterationsField; // max number of iterations field  
    JTextField clusterField; // max number of clusters  

    // declare components for lp order in the LP algorithm
    //
    JLabel lporderLabel; // LP order label
    JTextField lporderField; // LP order text field  

    // declare components for interpolation in the LP and PF algorithm
    //
    JLabel iporderLabel; // interpolation order label
    JTextField iporderField; // interpolation order text field 

    // declare components for obs in the Kalman Filter (KF) algorithm
    //
    JLabel obsLabel; 
    JTextField obsField;

    // declare components for trn in the Kalman Filter (KF) algorithm
    //
    JLabel trnLabel;
    JTextField trnField;   

    // declare components for var_obs order in the kf and pf algorithm
    //
    JLabel covar_nse_proLabel;
    JTextField covar_nse_proField;

    // declare components for covar_nse_obs in the kf and pf algorithm
    //
    JLabel covar_nse_obsLabel; 
    JTextField covar_nse_obsField;

    // declare components for covar_nse_err in the kf and pf algorithm
    //
    JLabel covar_nse_errLabel; 
    JTextField covar_nse_errField;

    // declare components for particles in the particle filter algorithm
    //
    JLabel particles_label; 
    JTextField particlesField;

    // declare components for covtype in the HLDA algorithm
    // Tao
    //
    JLabel covtypeLabel; 
    //JTextField covtypeField;
    JRadioButton equalRadioButton;
    JRadioButton diagonalRadioButton;
    JRadioButton unequalRadioButton;
    ButtonGroup covtype_group = new ButtonGroup();

    // declare components for hlda_initype in the HLDA algorithm
    // Tao
    //
    JLabel hlda_initypeLabel; 
    //JTextField hlda_initypeField;
    JRadioButton ldaRadioButton;
    JRadioButton identityRadioButton;
    ButtonGroup hlda_initype_group = new ButtonGroup();

    // declare components for alpha in the unscented Kalman Filter
    //  (UKF) algorithm
    //
    JLabel alphaLabel; 
    JTextField alphaField;

    // declare components for beta in the unscented Kalman Filter
    //  (UKF) algorithm
    //
    JLabel betaLabel; 
    JTextField betaField;

    // declare components for kappa in the unscented Kalman Filter
    //  (UKF) algorithm
    //
    JLabel kappaLabel; 
    JTextField kappaField;

   //  // declare a checkbox item listener
    //  //
    //  CheckBoxListener myListener = new CheckBoxListener();

    // declare strings for the Help menu
    //
    String helpOption = new String("Help");
    String tutorial = new String("Applet Tutorial");
    String overview = new String("Applet Overview");
    String release = new String("Release Notes");
    String info = new String("Information and Support");
    String plugins = new String("About Plug-ins");
    String done = new String("Done");
    String refresh = new String("Update");
    String apply = new String("OK");
    String destroy = new String("Cancel");
    String setpara = new String("Set K-Means");
    String newline = new String("\n");  


    // declare strings for the color changer dialog
    //
    String changeset = new String("Change");
    String changeset1 = new String("Change1");  
    String changeset2 = new String("Change2");  
    String changeset3 = new String("Change3");  
    String changeset4 = new String("Change4");  

    // declare menu title strings
    //
    String drwpts = new String("Draw Points");
    String drwgauss = new String("Draw Gaussian");
    String pearEllipse = new String("Pear And Ellipse");
    String twoEllipse = new String("Two Ellipse");
    String twoGaussian = new String("Two Gaussian");
    String fourGaussian = new String("Four Gaussian");
    String overGaussian = new String("Overlapping Gaussian");
    String twoEllipses = new String("Two Ellipses");
    String fourEllipses = new String("Four Ellipses");
    String rotatedEllipses = new String("Rotated Ellipses");
    String toroidal = new String("Toroidal");
    String randomSignal = new String("Random Signal");
    String lorentzSignal = new String("Lorentz Signal");
    String yinYang = new String("Yin and Yang");
    String class1 = new String("Input Class 0");
    String class2 = new String("Input Class 1");
    String class3 = new String("Input Class 2");
    String class4 = new String("Input Class 3");
    String euclidean = new String("Euclidean Distance");
    String nearest = new String("Nearest Neighbor");
    String kmeans = new String("Clustering: K-Means");
    String binary = new String("Clustering: LBG");
    String LDA1 = new String("LDA: Class-Independent");

    // Tao
    String HLDA = new String("HLDA: Heteroscedastic Linear Discriminant Analysis");

    String LDA2 = new String("LDA: Class-Dependent");
    String PCA1 = new String("PCA: Class-Independent");
    String PCA2 = new String("PCA: Class-Dependent");
    String LDAPCA1 = new String("LDA->PCA: Class-Independent");
    String LDAPCA2 = new String("LDA->PCA: Class-Dependent");
    String ICA1 = new String("ICA: Class-Independent");
    String ICA2 = new String("ICA: Class-Dependent");
    String SVM1 = new String("SVM: Class-Independent");
    String SVM2 = new String("RVM: Relevance Vector Machine");
    String LP = new String("LP: Linear Prediction");
    String KF = new String("KF: Kalman Filtering");
    String UKF = new String("UKF: Unscented Kalman Filtering");
    String PF = new String("PF: Particle Filtering");

    String previous = new String("Previous");
    String setgaus = new String ("Set Gaussian");
    String setccolors = new String ("Set Class Colors");
    String setalgoparams = new String ("Set Algorithm Parameters");
    String setiterations = new String ("Set Iterations");
    String setclusters = new String ("Set Clusters");
    String setlporders = new String ("Set LP Order");
    String setiporders = new String ("Set Interpolation");
    String set_obs = new String ("Set Observation Matrix");
    String set_trn = new String ("Set State Transition Matrix");
    String set_covar_nse_obs = new String ("Set Measurement Noise Variance");
    String set_covar_nse_pro = new String("Set Process Noise Variance");
    String set_covar_nse_err = new String("Set Estimate Error Variance");
    String set_particles = new String ("Set Number of Particles");

    // Tao
    String setcovtype = new String("Set Covariance Matrix Type");
    String sethlda_initype = new String("Set HLDA Initialization");

    String setalpha = new String("Set Alpha");
    String setbeta = new String("Set Beta");
    String setkappa = new String("Set Kappa");
    String saveiporders = new String ("Save Interpolation Order");
    String saveiterations = ("Save Iterations");
    String saveclusters = ("Save Clusters");
    String savelporders = ("Save LP Order");
    String save_obs = new String ("Save Measurement Gain");
    String save_trn = new String ("Save State Gain");
    String save_covar_nse_pro = new String("Save Process Noise Variance");
    String save_covar_nse_obs = new String ("Save Measurement Noise Variance");
    String save_covar_nse_err = new String ("Save Estimate Error Variance");
    String saveparticles = new String ("Save Number of Particles");

    String applykmeansparamslbl = new String("Apply K-Means Parameters");
    String applylbgparamslbl = new String("Apply LBG Parameters");
    String applyhldaparamslbl = new String("Apply HLDA Parameters");
    String applylpparamslbl = new String("Apply LP Parameters");
    String applykfparamslbl = new String("Apply KF Parameters");
    String applyukfparamslbl = new String("Apply UKF Parameters");
    String applypfparamslbl = new String("Apply PF Parameters");

    // Tao
    String savecovtype = new String("Save Covariance Matrix Type");
    String savehlda_initype = new String("Save HLDA Initialization Type");

    String savealpha = new String("Save Alpha");
    String savebeta = new String("Save Beta");
    String savekappa = new String("Save Kappa");

    String clearAll = new String("Clear All");
    String clearPlots = new String("Clear Display");
    String clearInput = new String("Clear Input");
    String clearOutput = new String("Clear Output");
    String clearTxt = new String("Clear Description");
    String erase = new String("Erase");
    String zoomin = new String("Zoom In");  
    String zoomout = new String("Zoom Out");  
    String limit = new String("Set Ranges");
    String next = new String("Next");
    String load = new String("Load");
    String save = new String("Save");
    String initialize = new String("Initialize");
    String viewEuclidean = new String("View Euclidean");
    String viewNearest = new String("View Nearest Neighbor");
    String viewPCA1 = new String("PCA: Class Independent PCA");
    String viewPCA2 = new String("PCA: Class Dependent PCA");
    String viewLDA1 = new String("LDA: Class Independent LDA");

    // Tao
    String viewHLDA = new String("Heteroscedastic Linear Discriminant Analysis");

    String viewLDA2 = new String("LDA: Class Dependent LDA");
    String viewLDAPCA1 = new String("LDA->PCA: Class Independent LDA->PCA");
    String viewLDAPCA2 = new String("LDA->PCA: Class Dependent LDA->PCA");
    String viewICA1 = new String("ICA: Class Independent PCA");
    String viewICA2 = new String("ICA: Class Dependent LDA");
    String viewSVM1 = new String("SVM: Class Independent PCA");
    //String viewSVM2 = new String("SVM: Class Dependent LDA");
    String viewSVM2 = new String("SVM: Relevance Vector Machine");
    String viewLP = new String("LP: Linear Prediction");
    String viewKF = new String("KF: Kalman Filtering");
    String viewUKF = new String("UKF: Unscented Kalman Filtering");
    String viewPF = new String("PF: Particle Filtering");
    String viewKMeans = new String("Clustering : K-Means");
    String viewLBG = new String("Clustering : LBG");
  
    // *********************************************************************
    //
    // declare class 
    /**
     *
     * constructor initializes objects and containers
     *
     * @param   vec vector of url's
     * @param   con applet context
     *
     */
    MainMenu(Vector vec, AppletContext con)
    {

	super();

	// initialize the input and output panel objects
	//
	urlvec = vec;
	context = con;

	// initialize the labels and text fields
	//
	xMinLabel = new JLabel("X minimum:   ");
	xMaxLabel = new JLabel("X maximum:   ");
	yMinLabel = new JLabel("Y minimum:   ");
	yMaxLabel = new JLabel("Y maximum:   ");

	xMinField = new JTextField("-1.0", 10);
	xMaxField = new JTextField("1.0", 10);
	yMinField = new JTextField("-1.0", 10);
	yMaxField = new JTextField("1.0", 10);

	colorselection = new JLabel("Select Class Colors");
	dset1color = new JLabel("Class 0");
	dset2color = new JLabel("Class 1");
	dset3color = new JLabel("Class 2");
	dset4color = new JLabel("Class 3");

	kmeansparamlbl = new JLabel("Set K-Means Parameters");
	hldaparamlbl = new JLabel("Set HLDA Parameters");
	lpparamlbl = new JLabel("Set Linear Prediction Parameters");
	kfparamlbl = new JLabel("Set Kalman Filter Parameters");
	ukfparamlbl = new JLabel("Set UKF Parameters");
	pfparamlbl = new JLabel("Set Particle Filter Parameters");

	kmeansIterLbl = new JLabel("Iterations: ");
	kmeansIterFld = new JTextField("10", 10);
	kmeansClustersLbl = new JLabel("Clusters: ");
	kmeansClustersFld = new JTextField("10", 10);

	pointsLabel = new JLabel("Points : ");
	meanxLabel = new JLabel("Mean(X): ");
	meanyLabel = new JLabel("Mean(Y): ");
	setgausLabel = new JLabel("Gaussian Settings");
	covLabel = new JLabel("Covariance:");
	cov11Label = new JLabel("  Cov[1,1]: ");
	cov12Label = new JLabel("  Cov[1,2]: ");
	cov21Label = new JLabel("  Cov[2,1]: ");
	cov22Label = new JLabel("  Cov[2,2]: ");

	pointsField = new JTextField("25", 10);
	meanxField = new JTextField("0.0", 10);
	meanyField = new JTextField("0.0", 10);
	cov11Field = new JTextField("0.05", 10);
	cov12Field = new JTextField("0.0", 10);
	cov21Field = new JTextField("0.0", 10);
	cov22Field = new JTextField("0.05", 10);

	lporderLabel = new JLabel("LP Order: ");
	lporderField = new JTextField("3", 10);

	iporderLabel = new JLabel("Interpolation Order: ");
	iporderField = new JTextField("10", 10);

	obsLabel = new JLabel("Observation Matrix: ");
	obsField = new JTextField("1.0", 10);

	trnLabel = new JLabel("State Transition Matrix: ");
	trnField = new JTextField("1.5", 10);

	covar_nse_proLabel = new JLabel("Process Noise Variance: ");
	covar_nse_proField = new JTextField("0.1", 10);

	covar_nse_obsLabel = new JLabel("Observation Noise Variance: ");
	covar_nse_obsField = new JTextField("0.1", 10);

	covar_nse_errLabel = new JLabel("Estimate Error Variance: ");
	covar_nse_errField = new JTextField("0.1", 10);

	particles_label = new JLabel("Number of Particles: ");
	particlesField = new JTextField("50", 10);

	// Tao
	covtypeLabel = new JLabel("Covariance Matrix:");
	//covtypeField = new JTextField("1", 10);
	equalRadioButton = new JRadioButton("Equal");
	equalRadioButton.setSelected(true);
	diagonalRadioButton = new JRadioButton("Diagonal");
	unequalRadioButton = new JRadioButton("Unequal");
	covtype_group = new ButtonGroup();
	covtype_group.add(equalRadioButton);
	covtype_group.add(diagonalRadioButton);
	covtype_group.add(unequalRadioButton);

	// Tao
	hlda_initypeLabel = new JLabel("Initialization Method:");
	//hlda_initypeField = new JTextField("1", 10);
	ldaRadioButton = new JRadioButton("LDA");
	ldaRadioButton.setSelected(true);
	identityRadioButton = new JRadioButton("Identity");
	hlda_initype_group = new ButtonGroup();
	hlda_initype_group.add(ldaRadioButton);
	hlda_initype_group.add(identityRadioButton);

	alphaLabel = new JLabel("Alpha: ");
	alphaField = new JTextField("1.0", 10);

	betaLabel = new JLabel("Beta: ");
	betaField = new JTextField("2.0", 10);

	kappaLabel = new JLabel("Kappa: ");
	kappaField = new JTextField("0.0", 10);

	// create a border around the control panel
	//
	setBorder(BorderFactory.createEtchedBorder());

	// create components for the help box
	//
	frame = new JFrame();

	// create components for the help box
	//
	setccolorsdlg = new JFrame();

	// create components for algorithm parameters dialogs
	//
	// kmeans
	//
	setkmeansdlg = new JFrame();
	
	// HLDA
	//
	sethldadlg = new JFrame();
	
	// LP
	//
	setlpdlg = new JFrame();
	
	// KF
	//
	setkfdlg = new JFrame();
	
	// create a frame for the time scales
	//
	scale = new JFrame();

	// create a frame for the gaussian distribution
	//
	setgausdlg = new JFrame();

	// create a frame for the k-mean algorithm
	//
	clusterpara = new JFrame();

	// create a frame for the k-mean algorithm
	//
	iterpara = new JFrame();

	// create a frame for the LP set order box
	//
	lpsetorderpara = new JFrame();

	// create a frame for interpoloation in the LP set order box
	//
	ipsetorderpara = new JFrame();

	// create a frame for the measurement gain for KF
	//
	setobsFrame = new JFrame();

	// create a frame for the state gain for KF
	//
	settrnFrame = new JFrame();

	// create a frame for the measurement noise variance 
	// for KF, UKF, and PF
	//
	setcovar_nse_proFrame = new JFrame();

	// create a frame for the process noise variance
	// for KF, UKF, and PF
	//
	setcovar_nse_obsFrame = new JFrame();

	// create a frame for the estimate error variance
	// for KF, UKF, and PF
	//
	setcovar_nse_errFrame = new JFrame();

	// create a frame for the number of gaussian samples for PF
	//
	setparticlesFrame = new JFrame();

	// create a frame for covtype for HLDA
	// Tao
	setcovtypeFrame = new JFrame();

	// create a frame for hlda_initype for HLDA
	// Tao
	sethlda_initypeFrame = new JFrame();

	// create a frame for alpha for UKF
	//
	setalphaFrame = new JFrame();

	// create a frame for beta for UKF
	//
	setbetaFrame = new JFrame();

	// create a frame for kapp for UKF
	//
	setkappaFrame = new JFrame();

	// create the textbox to view the help message
	//
	textArea = new JTextArea();
	textArea.setLineWrap(true);
	textArea.setWrapStyleWord(true);
	textArea.setEditable(false);

	// make the text area scrollable
	//
	scrollPane = new JScrollPane(textArea);

	// set the scroll pane dismensions
	//
	scrollPane.setSize(new Dimension(400, 400));
	scrollPane.setPreferredSize(new Dimension(400, 400));
	scrollPane.setMinimumSize(new Dimension(400, 400));
	scrollPane.setMaximumSize(new Dimension(400, 400));

	// create a dismiss button for the text area
	//
	dismiss = new JButton(done);
	dismiss.setActionCommand(done);
	dismiss.addActionListener(this);

	// create a dismiss button for the text area
	//
	change = new JButton(refresh);
	change.setActionCommand(refresh);
	change.addActionListener(this);

	// create a button for setting color of class 1
	//
	setdset1 = new JButton(changeset);
	setdset1.setActionCommand(changeset1);
	setdset1.addActionListener(this);

	// create a button for setting color of class 2
	//
	setdset2 = new JButton(changeset);
	setdset2.setActionCommand(changeset2);
	setdset2.addActionListener(this);

	// create a button for setting color of class 3
	//
	setdset3 = new JButton(changeset);
	setdset3.setActionCommand(changeset3);
	setdset3.addActionListener(this);

	// create a button for setting color of class 4
	//
	setdset4 = new JButton(changeset);
	setdset4.setActionCommand(changeset4);
	setdset4.addActionListener(this);

	// create a button for setting color of class 4
	//
	setcolors = new JButton(done);
	setcolors.setActionCommand(done);
	setcolors.addActionListener(this);

	// set the size of the color preview panels
	//
	paneldset1.setPreferredSize(new Dimension(30,20));
	paneldset2.setPreferredSize(new Dimension(30,20));
	paneldset3.setPreferredSize(new Dimension(30,20));
	paneldset4.setPreferredSize(new Dimension(30,20));

	// create a generate button for the gaussian distribution
	//
	applyb = new JButton(apply);
	applyb.setActionCommand(apply);
	applyb.addActionListener(this);

	// create a cancel button for the gaussian distribution
	//
	cancel = new JButton(destroy);
	cancel.setActionCommand(destroy);
	cancel.addActionListener(this);

	// create a initialize button for the k-means algorithm
	//
	initcluster = new JButton(setclusters);
	initcluster.setActionCommand(saveclusters);
	initcluster.addActionListener(this);

	// create an apply button for kmeans algorithm
	//
	applykmeansparamsbttn = new JButton(applykmeansparamslbl);
	applykmeansparamsbttn.setActionCommand(applykmeansparamslbl);
	applykmeansparamsbttn.addActionListener(this);

	// create an apply button for hlda algorithm
	//
	applyhldaparamsbttn = new JButton(applyhldaparamslbl);
	applyhldaparamsbttn.setActionCommand(applyhldaparamslbl);
	applyhldaparamsbttn.addActionListener(this);

	// create an apply button for lp algorithm
	//
	applylpparamsbttn = new JButton(applylpparamslbl);
	applylpparamsbttn.setActionCommand(applylpparamslbl);
	applylpparamsbttn.addActionListener(this);
	
	// create an apply button for kf algorithm
	//
	applykfparamsbttn = new JButton(applykfparamslbl);
	applykfparamsbttn.setActionCommand(applykfparamslbl);
	applykfparamsbttn.addActionListener(this);

	// create an apply button for ukf algorithm
	//
	applyukfparamsbttn = new JButton(applyukfparamslbl);
	applyukfparamsbttn.setActionCommand(applyukfparamslbl);
	applyukfparamsbttn.addActionListener(this);

	// create an apply button for pf algorithm
	//
	applypfparamsbttn = new JButton(applypfparamslbl);
	applypfparamsbttn.setActionCommand(applypfparamslbl);
	applypfparamsbttn.addActionListener(this);


	// create a initialize button for the Linear Prediction algorithm
	//
	initlporder = new JButton(refresh);
	initlporder.setActionCommand(savelporders);
	initlporder.addActionListener(this);

	// create a initialize button for the LP algorithm
	//
	initiporder = new JButton(refresh);
	initiporder.setActionCommand(saveiporders);
	initiporder.addActionListener(this);

	// create a initialize button for the obs Kalman Filter (KF) algorithm
	//
	initobs = new JButton(refresh);
	initobs.setActionCommand(save_obs);
	initobs.addActionListener(this);

	// create a initialize button for the trn Kalman Filter (KF) algorithm
	//
	inittrn = new JButton(refresh);
	inittrn.setActionCommand(save_trn);
	inittrn.addActionListener(this);

	// create a initialize button for the covar_nse_pro 
	// Kalman and particle algorithm
	//
	initcovar_nse_pro = new JButton(refresh);
	initcovar_nse_pro.setActionCommand(save_covar_nse_pro);
	initcovar_nse_pro.addActionListener(this);

	// create a initialize button for the covar_nse_obs
	//  Kalman and particle algorithm
	//
	initcovar_nse_obs = new JButton(refresh);
	initcovar_nse_obs.setActionCommand(save_covar_nse_obs);
	initcovar_nse_obs.addActionListener(this);

	// create a initialize button for the covar_nse_err
	//  Kalman and particle algorithm
	//
	initcovar_nse_err = new JButton(refresh);
	initcovar_nse_err.setActionCommand(save_covar_nse_err);
	initcovar_nse_err.addActionListener(this);

	// create a initialize button for the particles, particle algorithm
	//
	initparticles = new JButton(refresh);
	initparticles.setActionCommand(saveparticles);
	initparticles.addActionListener(this);


	// create a initialize button for covtype, HLDA algorithm
	// Tao
	initcovtype = new JButton(refresh);
	initcovtype.setActionCommand(savecovtype);
	initcovtype.addActionListener(this);

	// create a initialize button for hlda_initype, HLDA algorithm
	// Tao
	inithlda_initype = new JButton(refresh);
	inithlda_initype.setActionCommand(savehlda_initype);
	inithlda_initype.addActionListener(this);

	// create a initialize button for alpha, UKF algorithm
	//
	initalpha = new JButton(refresh);
	initalpha.setActionCommand(savealpha);
	initalpha.addActionListener(this);

	// create a initialize button for beta, UKF algorithm
	//
	initbeta = new JButton(refresh);
	initbeta.setActionCommand(savebeta);
	initbeta.addActionListener(this);

	// create a initialize button for kappa, UKF algorithm
	//
	initkappa = new JButton(refresh);
	initkappa.setActionCommand(savealpha);
	initkappa.addActionListener(this);

	// create a initialize button for the LBG algorithm
	//
	inititer = new JButton(setiterations);
	inititer.setActionCommand(saveiterations);
	inititer.addActionListener(this);

	// add the components to frame
	//
	frame.getContentPane().add(scrollPane, BorderLayout.CENTER);
	frame.getContentPane().add(dismiss, BorderLayout.SOUTH);

	// set the container layout for the scale components
	//
	GridBagLayout gridbag = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();

	// define constraints for all components
	//
	c.weightx = 1.0;
	c.weighty = 1.0;
	c.gridheight = 1;
	c.anchor = GridBagConstraints.WEST;
	c.fill = GridBagConstraints.HORIZONTAL;

	// add the components for the scale frame
	//
	c.gridx = 0;
	c.gridy = 1;
	c.gridwidth = 1;
	scale.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(xMinLabel, c);
	scale.getContentPane().add(xMinLabel);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(xMinField, c);
	scale.getContentPane().add(xMinField);

	c.gridx = 0;
	c.gridy = 2;
	c.gridwidth = 1;
	gridbag.setConstraints(xMaxLabel, c);
	scale.getContentPane().add(xMaxLabel);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(xMaxField, c);
	scale.getContentPane().add(xMaxField);

	c.gridx = 0;
	c.gridy = 3;
	c.gridwidth = 1;
	gridbag.setConstraints(yMinLabel, c);
	scale.getContentPane().add(yMinLabel);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(yMinField, c);
	scale.getContentPane().add(yMinField);

	c.gridx = 0;
	c.gridy = 4;
	c.gridwidth = 1;
	gridbag.setConstraints(yMaxLabel, c);
	scale.getContentPane().add(yMaxLabel);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(yMaxField, c);
	scale.getContentPane().add(yMaxField);

	c.gridx = 0;
	c.gridy = 6;
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.anchor = GridBagConstraints.CENTER;
	gridbag.setConstraints(change, c);
	scale.getContentPane().add(change);

	// set the container layout for the gaussian distribution
	//
	c = new GridBagConstraints();
	c.weightx = 1.0;
	c.weighty = 1.0;
	c.gridheight = 1;
	c.fill = GridBagConstraints.NONE;

	// add the components for the set colors dlg
	//
	c.gridx = 0;
	c.gridy = 0;
	c.gridwidth = 2;
	setccolorsdlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(colorselection, c);
	setccolorsdlg.getContentPane().add(colorselection);

	c.gridx = 0;
	c.gridy = 1;
	c.gridwidth = 1;
	c.anchor = GridBagConstraints.WEST;
	gridbag.setConstraints(dset1color, c);
	setccolorsdlg.getContentPane().add(dset1color);

	c.gridx = 1;
	c.gridy = 1;
	c.gridwidth = 1;
	gridbag.setConstraints(paneldset1, c);
	setccolorsdlg.getContentPane().add(paneldset1);

	c.gridx = 2;
	c.gridy = 1;
	c.gridwidth = 1;
	gridbag.setConstraints(setdset1, c);
	setccolorsdlg.getContentPane().add(setdset1);

	c.gridx = 0;
	c.gridy = 2;
	c.gridwidth = 1;
	c.anchor = GridBagConstraints.WEST;
	gridbag.setConstraints(dset2color, c);
	setccolorsdlg.getContentPane().add(dset2color);

	c.gridx = 1;
	c.gridy = 2;
	c.gridwidth = 1;
	gridbag.setConstraints(paneldset2, c);
	setccolorsdlg.getContentPane().add(paneldset2);

	c.gridx = 2;
	c.gridy = 2;
	c.gridwidth = 1;
	gridbag.setConstraints(setdset2, c);
	setccolorsdlg.getContentPane().add(setdset2);

	c.gridx = 0;
	c.gridy = 3;
	c.gridwidth = 1;
	c.anchor = GridBagConstraints.WEST;
	gridbag.setConstraints(dset3color, c);
	setccolorsdlg.getContentPane().add(dset3color);

	c.gridx = 1;
	c.gridy = 3;
	c.gridwidth = 1;
	gridbag.setConstraints(paneldset3, c);
	setccolorsdlg.getContentPane().add(paneldset3);

	c.gridx = 2;
	c.gridy = 3;
	c.gridwidth = 1;
	gridbag.setConstraints(setdset3, c);
	setccolorsdlg.getContentPane().add(setdset3);

	c.gridx = 0;
	c.gridy = 4;
	c.gridwidth = 1;
	c.anchor = GridBagConstraints.WEST;
	gridbag.setConstraints(dset4color, c);
	setccolorsdlg.getContentPane().add(dset4color);    

	c.gridx = 1;
	c.gridy = 4;
	c.gridwidth = 1;
	gridbag.setConstraints(paneldset4, c);
	setccolorsdlg.getContentPane().add(paneldset4);


	c.gridx = 2;
	c.gridy = 4;
	c.gridwidth = 1;
	gridbag.setConstraints(setdset4, c);
	setccolorsdlg.getContentPane().add(setdset4);

	c.gridx = 0;
	c.gridy = 6;
	c.gridwidth = 3; 
	c.insets = new Insets(7,7,7,7);
	c.anchor = GridBagConstraints.CENTER;
	gridbag.setConstraints(setcolors, c);
	setccolorsdlg.getContentPane().add(setcolors);

        // set container layout for k-means parameter configuration
	//
	c = new GridBagConstraints();
	c.weightx = 1.0;
	c.weighty = 1.0;
	c.gridheight = 1;
	c.fill = GridBagConstraints.NONE;

	c.gridx = 0;
	c.gridy = 0;
	c.gridwidth = 2;
	c.anchor = GridBagConstraints.CENTER;
	setkmeansdlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(kmeansparamlbl, c);
	setkmeansdlg.getContentPane().add(kmeansparamlbl);
	
	c.gridx = 0;
	c.gridy = 1;
	c.gridwidth = 1;
	c.anchor = GridBagConstraints.WEST;
	gridbag.setConstraints(kmeansIterLbl, c);
	setkmeansdlg.getContentPane().add(kmeansIterLbl);

	c.gridx = 1;
	c.gridy = 1;
	c.gridwidth = 1;
	gridbag.setConstraints(kmeansIterFld, c);
	setkmeansdlg.getContentPane().add(kmeansIterFld);

	c.gridx = 0;
	c.gridy = 2;
	c.gridwidth = 1;
	c.anchor = GridBagConstraints.WEST;
	gridbag.setConstraints(kmeansClustersLbl, c);
	setkmeansdlg.getContentPane().add(kmeansClustersLbl);

	c.gridx = 1;
	c.gridy = 2;
	c.gridwidth = 1;
	gridbag.setConstraints(kmeansClustersFld, c);
	setkmeansdlg.getContentPane().add(kmeansClustersFld);

	c.gridx = 0;
	c.gridy = 3;
	c.gridwidth = 2;
	gridbag.setConstraints(applykmeansparamsbttn, c);
	setkmeansdlg.getContentPane().add(applykmeansparamsbttn);
	
        // set container layout for HLDA parameter configuration
	//
	c = new GridBagConstraints();
	c.weightx = 1.0;
	c.weighty = 1.0;
	c.gridheight = 1;
	c.fill = GridBagConstraints.NONE;

	c.gridx = 0;
	c.gridy = 0;
	c.gridwidth = 2;
	sethldadlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(hldaparamlbl, c);
	sethldadlg.getContentPane().add(hldaparamlbl);

	c.anchor = GridBagConstraints.WEST;

	c.gridx = 0;
	c.gridy = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	sethldadlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(covtypeLabel, c);
	sethldadlg.getContentPane().add(covtypeLabel);

	c.gridx = 0;
	c.gridy = 2;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(equalRadioButton, c);
	sethldadlg.getContentPane().add(equalRadioButton);

	c.gridx = 0;
	c.gridy = 3;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(diagonalRadioButton, c);
	sethldadlg.getContentPane().add(diagonalRadioButton);

	c.gridx = 0;
	c.gridy = 4;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(unequalRadioButton, c);
	sethldadlg.getContentPane().add(unequalRadioButton);

	c.gridx = 0;
	c.gridy = 5;
	c.gridwidth = GridBagConstraints.REMAINDER;
	sethldadlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(hlda_initypeLabel, c);
	sethldadlg.getContentPane().add(hlda_initypeLabel);

	c.gridx = 0;
	c.gridy = 6;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(ldaRadioButton, c);
	sethldadlg.getContentPane().add(ldaRadioButton);

	c.gridx = 0;
	c.gridy = 7;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(identityRadioButton, c);
	sethldadlg.getContentPane().add(identityRadioButton);

	c.gridx = 0;
	c.gridy = 8;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(applyhldaparamsbttn, c);
	sethldadlg.getContentPane().add(applyhldaparamsbttn);

        // set container layout for lp parameter configuration
	//
	c = new GridBagConstraints();
	c.weightx = 1.0;
	c.weighty = 1.0;
	c.gridheight = 1;
	c.fill = GridBagConstraints.NONE;

	c.gridx = 0;
	c.gridy = 0;
	c.gridwidth = 2;
	setlpdlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(lpparamlbl, c);
	setlpdlg.getContentPane().add(lpparamlbl);

	c.anchor = GridBagConstraints.WEST;

	c.gridx = 0;
	c.gridy = 1;
	c.gridwidth = 1;
	setlpdlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(lporderLabel, c);
	setlpdlg.getContentPane().add(lporderLabel);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(lporderField, c);
	setlpdlg.getContentPane().add(lporderField);
	
	c.gridx = 0;
	c.gridy = 2;
	c.gridwidth = 1;
	ipsetorderpara.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(iporderLabel, c);
	setlpdlg.getContentPane().add(iporderLabel);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(iporderField, c);
	setlpdlg.getContentPane().add(iporderField);

	c.anchor = GridBagConstraints.CENTER;

	c.gridx = 0;
	c.gridy = 3;
	c.gridwidth = 2;
	gridbag.setConstraints(applylpparamsbttn, c);
	setlpdlg.getContentPane().add(applylpparamsbttn);

        // set container layout for kf parameter configuration
	//
	c = new GridBagConstraints();
	c.weightx = 1.0;
	c.weighty = 1.0;
	c.gridheight = 1;
	c.fill = GridBagConstraints.NONE;

	c.gridx = 0;
	c.gridy = 0;
	c.gridwidth = 2;
	setkfdlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(kfparamlbl, c);
	setkfdlg.getContentPane().add(kfparamlbl);

	c.anchor = GridBagConstraints.WEST;

	c.gridx = 0;
	c.gridy = 1;
	c.gridwidth = 1;
	setkfdlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(trnLabel, c);
	setkfdlg.getContentPane().add(trnLabel);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(trnField, c);
	setkfdlg.getContentPane().add(trnField);

	c.gridx = 0;
	c.gridy = 2;
	c.gridwidth = 1;
	setkfdlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(obsLabel, c);
	setkfdlg.getContentPane().add(obsLabel);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(obsField, c);
	setkfdlg.getContentPane().add(obsField);


	c.gridx = 0;
	c.gridy = 3;
	c.gridwidth = 1;
	setkfdlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(covar_nse_obsLabel, c);
	setkfdlg.getContentPane().add(covar_nse_obsLabel);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(covar_nse_obsField, c);
	setkfdlg.getContentPane().add(covar_nse_obsField);

	c.gridx = 0;
	c.gridy = 4;
	c.gridwidth = 1;
	setkfdlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(covar_nse_proLabel, c);
	setkfdlg.getContentPane().add(covar_nse_proLabel);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(covar_nse_proField, c);
	setkfdlg.getContentPane().add(covar_nse_proField);

	c.gridx = 0;
	c.gridy = 5;
	c.gridwidth = 1;
	setkfdlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(covar_nse_errLabel, c);
	setkfdlg.getContentPane().add(covar_nse_errLabel);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(covar_nse_errField, c);
	setkfdlg.getContentPane().add(covar_nse_errField);

	c.gridx = 0;
	c.gridy = 6;
	c.gridwidth = 1;
	setkfdlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(particles_label, c);
	setkfdlg.getContentPane().add(particles_label);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(particlesField, c);
	setkfdlg.getContentPane().add(particlesField);

	c.gridx = 0;
	c.gridy = 7;
	c.gridwidth = 1;
	setkfdlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(alphaLabel, c);
	setkfdlg.getContentPane().add(alphaLabel);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(alphaField, c);
	setkfdlg.getContentPane().add(alphaField);

	c.gridx = 0;
	c.gridy = 8;
	c.gridwidth = 1;
	setkfdlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(betaLabel, c);
	setkfdlg.getContentPane().add(betaLabel);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(betaField, c);
	setkfdlg.getContentPane().add(betaField);

	c.gridx = 0;
	c.gridy = 9;
	c.gridwidth = 1;
	setkfdlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(kappaLabel, c);
	setkfdlg.getContentPane().add(kappaLabel);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(kappaField, c);
	setkfdlg.getContentPane().add(kappaField);

	c.anchor = GridBagConstraints.CENTER;

	c.gridx = 0;
	c.gridy = 10;
	c.gridwidth = 2;
	gridbag.setConstraints(applykfparamsbttn, c);
	setkfdlg.getContentPane().add(applykfparamsbttn);

	// set the container layout for the gaussian distribution
	//
	c.weightx = 1.0;
	c.weighty = 1.0;
	c.gridheight = 1;
	c.anchor = GridBagConstraints.WEST;
	c.fill = GridBagConstraints.HORIZONTAL;

	// add the components for the gaussian distribution
	//
	c.gridx = 0;
	c.gridy = 0;
	c.gridwidth = GridBagConstraints.REMAINDER;
	setgausdlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(setgausLabel, c);
	setgausdlg.getContentPane().add(setgausLabel);

	c.gridx = 0;
	c.gridy = 1;
	c.gridwidth = 1;
	setgausdlg.getContentPane().setLayout(gridbag);
	gridbag.setConstraints(pointsLabel, c);
	setgausdlg.getContentPane().add(pointsLabel);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(pointsField, c);
	setgausdlg.getContentPane().add(pointsField);


	c.gridx = 0;
	c.gridy = 2;
	c.gridwidth = 1;
	gridbag.setConstraints(covLabel, c);
	setgausdlg.getContentPane().add(covLabel);

	c.gridx = 0;
	c.gridy = 3;
	c.gridwidth = 1;
	gridbag.setConstraints(cov11Label, c);
	setgausdlg.getContentPane().add(cov11Label);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(cov11Field, c);
	setgausdlg.getContentPane().add(cov11Field);

	c.gridx = 0;
	c.gridy = 4;
	c.gridwidth = 1;
	gridbag.setConstraints(cov12Label, c);
	setgausdlg.getContentPane().add(cov12Label);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(cov12Field, c);
	setgausdlg.getContentPane().add(cov12Field);

	c.gridx = 0;
	c.gridy = 5;
	c.gridwidth = 1;
	gridbag.setConstraints(cov21Label, c);
	setgausdlg.getContentPane().add(cov21Label);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(cov21Field, c);
	setgausdlg.getContentPane().add(cov21Field);

	c.gridx = 0;
	c.gridy = 6;
	c.gridwidth = 1;
	gridbag.setConstraints(cov22Label, c);
	setgausdlg.getContentPane().add(cov22Label);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(cov22Field, c);
	setgausdlg.getContentPane().add(cov22Field);

	c.gridx = 0;
	c.gridy = 7;
	c.gridwidth = 1;
	c.anchor = GridBagConstraints.NORTHWEST;
	gridbag.setConstraints(applyb, c);
	setgausdlg.getContentPane().add(applyb);

	c.gridx = 1;
	c.gridwidth = GridBagConstraints.REMAINDER;
	c.anchor = GridBagConstraints.NORTHEAST;
	gridbag.setConstraints(cancel, c);
	setgausdlg.getContentPane().add(cancel);

	// create the menu bar item
	//
	menuBar = new JMenuBar();

	// build the File menu
	//
	menu = new JMenu("File");
	menu.setFont(newFont);
	menuBar.add(menu);

	// add the load menu item
	//
	menuItem = new JMenuItem(load);
	menuItem.setEnabled(false);
	menuItem.setFont(newFont);
	menuItem.addActionListener(this);
	menuItem.setActionCommand(load);
	menu.add(menuItem);

	// add the save menu item
	//
	menuItem = new JMenuItem(save);
	menuItem.setEnabled(false);
	menuItem.setFont(newFont);
	menuItem.addActionListener(this);
	menuItem.setActionCommand(save);
	menu.add(menuItem);

	// build the Edit menu
	//
	menu = new JMenu("Edit");
	menu.setFont(newFont);
	menuBar.add(menu);

	// add the settings menu
	// 
	JMenu expmenu = new JMenu("Settings");
	expmenu.setFont(newFont);

	// add the the scale menu item
	//
	menuItem = new JMenuItem(limit);
	menuItem.setFont(newFont);
	menuItem.addActionListener(this);
	menuItem.setActionCommand(limit);
	expmenu.add(menuItem);

	// add the setgaus menu item
	menuItem = new JMenuItem(setgaus);
	menuItem.setFont(newFont);
	menuItem.addActionListener(this);
	menuItem.setActionCommand(setgaus);
	expmenu.add(menuItem);

	// add the colors menu item
	menuItem = new JMenuItem(setccolors);
	menuItem.setFont(newFont);
	menuItem.addActionListener(this);
	menuItem.setActionCommand(setccolors);
	expmenu.add(menuItem);

	// add algo parameter menu item
	//	
	algoParamMenuItem = new JMenuItem(setalgoparams);
	algoParamMenuItem.setFont(newFont);
	algoParamMenuItem.addActionListener(this);
	algoParamMenuItem.setActionCommand(setalgoparams);
	expmenu.add(algoParamMenuItem);

	menu.add(expmenu);  

	menu.addSeparator();

	// add the the clear input menu item
	//
	menuItem = new JMenuItem(clearInput);
	menuItem.setFont(newFont);
	menuItem.addActionListener(this);
	menuItem.setActionCommand(clearInput);
	menu.add(menuItem);

	// add the the clear input menu item
	//
	menuItem = new JMenuItem(clearOutput);
	menuItem.setFont(newFont);
	menuItem.addActionListener(this);
	menuItem.setActionCommand(clearOutput);
	menu.add(menuItem);

	// add the the clear input menu item
	//
	menuItem = new JMenuItem(clearPlots);
	menuItem.setFont(newFont);
	menuItem.addActionListener(this);
	menuItem.setActionCommand(clearPlots);
	menu.add(menuItem);

	// add the the clear text menu item
	//
	menuItem = new JMenuItem(clearTxt);
	menuItem.setFont(newFont);
	menuItem.addActionListener(this);
	menuItem.setActionCommand(clearTxt);
	menu.add(menuItem);

	// add the the clear all menu item
	//
	menuItem = new JMenuItem(clearAll);
	menuItem.setFont(newFont);
	menuItem.addActionListener(this);
	menuItem.setActionCommand(clearAll);
	menu.add(menuItem);

	// build the View menu
	//
	menu = new JMenu("View");
	menu.setFont(newFont);
	menuBar.add(menu);

	// add the the zoomin menu item
	//
	menuItem = new JMenuItem(zoomin);
	menuItem.setFont(newFont);
	menuItem.setAccelerator(
	    KeyStroke.getKeyStroke(KeyEvent.VK_Z, InputEvent.ALT_MASK));
	menuItem.addActionListener(this);
	menuItem.setActionCommand(zoomin);
	menu.add(menuItem);

	// add the the scale zoomout item
	//
	menuItem = new JMenuItem(zoomout);
	menuItem.setFont(newFont);    
	menuItem.setAccelerator(
	    KeyStroke.getKeyStroke(KeyEvent.VK_X, InputEvent.CTRL_MASK));
	menuItem.addActionListener(this);
	menuItem.setActionCommand(zoomout);
	menu.add(menuItem);

	// build the Classes menu
	//
	menu = new JMenu("Classes");
	menu.setFont(newFont);
	menuBar.add(menu);

	// add a list of radio buttons to input classes menu
	//
	ButtonGroup group2 = new ButtonGroup();

	// add the 'Input Class A' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(class1);
	rbMenuItem.setFont(newFont);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(class1);
	rbMenuItem.setSelected(true);
	group2.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the 'Input Class B' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(class2);
	rbMenuItem.setFont(newFont);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(class2);
	group2.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the 'Input Class C' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(class3);
	rbMenuItem.setFont(newFont);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(class3);
	group2.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the 'Input Class D' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(class4);
	rbMenuItem.setFont(newFont);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(class4);
	group2.add(rbMenuItem);
	menu.add(rbMenuItem);

	// build the Patterns menu
	//
	menu = new JMenu("Patterns");
	menu.setFont(newFont);
	menuBar.add(menu);

	ButtonGroup drawgroup = new ButtonGroup();

	// add the 'Draw Points' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(drwpts);
	rbMenuItem.setFont(newFont);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(drwpts);
	rbMenuItem.setSelected(true);
	drawgroup.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the 'Draw Cluster' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(drwgauss);
	rbMenuItem.setFont(newFont);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(drwgauss);
	rbMenuItem.setSelected(false);
	drawgroup.add(rbMenuItem);
	menu.add(rbMenuItem);


	menu.addSeparator();

	ButtonGroup group3 = new ButtonGroup();

	// add the 'Two Gaussian' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(twoGaussian);
	rbMenuItem.setFont(newFont);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(twoGaussian);
	group3.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the 'Four Gaussian' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(fourGaussian);
	rbMenuItem.setFont(newFont);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(fourGaussian);
	group3.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the 'Overlapping Gaussian' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(overGaussian);
	rbMenuItem.setFont(newFont);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(overGaussian);
	group3.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the 'Two Ellipses' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(twoEllipses);
	rbMenuItem.setFont(newFont);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(twoEllipses);
	group3.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the 'Four Ellipses' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(fourEllipses);
	rbMenuItem.setFont(newFont);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(fourEllipses);
	group3.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the 'Rotated Ellipses' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(rotatedEllipses);
	rbMenuItem.setFont(newFont);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(rotatedEllipses);
	group3.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the 'Toroidal' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(toroidal);
	rbMenuItem.setFont(newFont);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(toroidal);
	group3.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the 'Yin and Yang' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(yinYang);
	rbMenuItem.setFont(newFont);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(yinYang);
	group3.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the 'Random Signal' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(randomSignal);
	rbMenuItem.setFont(newFont);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(randomSignal);
	group3.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the 'Lorentz Signal' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(lorentzSignal);
	rbMenuItem.setFont(newFont);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(lorentzSignal);
	group3.add(rbMenuItem);
	menu.add(rbMenuItem);

	// build the Algorithms menu
	//
	menu = new JMenu("Algorithms");
	menu.setFont(newFont);
	menuBar.add(menu);

	// add a list of radio buttons to algorithms menu
	//
	ButtonGroup group4 = new ButtonGroup();

	// add the 'Euclidean Distance' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(euclidean);
	rbMenuItem.setFont(newFont);
	rbMenuItem.setEnabled(true);
	rbMenuItem.setSelected(false);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(euclidean);
	group4.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the 'Nearest Neighbor' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(nearest);
	rbMenuItem.setFont(newFont);
	rbMenuItem.setEnabled(true);
	rbMenuItem.setSelected(false);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(nearest);
	group4.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the menu seperator
	//
	menu.addSeparator();

	// add the 'K-Means' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(kmeans);
	rbMenuItem.setFont(newFont);
	rbMenuItem.setEnabled(true);
	rbMenuItem.setSelected(false);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(kmeans);
	group4.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the 'Binary Clustering' option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(binary);
	rbMenuItem.setFont(newFont);
	rbMenuItem.setEnabled(true);
	rbMenuItem.setSelected(false);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(binary);
	group4.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the menu seperator
	//
	menu.addSeparator();

	// add the PCA1 option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(PCA1);
	rbMenuItem.setFont(newFont);
	rbMenuItem.setEnabled(true);
	rbMenuItem.setSelected(false);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(PCA1);
	group4.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the PCA2 option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(PCA2);
	rbMenuItem.setFont(newFont);
	rbMenuItem.setEnabled(true);
	rbMenuItem.setSelected(false);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(PCA2);
	group4.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the LDA1 option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(LDA1);
	rbMenuItem.setFont(newFont);
	rbMenuItem.setEnabled(true);
	rbMenuItem.setSelected(false);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(LDA1);
	group4.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the LDA2 option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(LDA2);
	rbMenuItem.setFont(newFont);
	rbMenuItem.setEnabled(true);
	rbMenuItem.setSelected(false);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(LDA2);
	group4.add(rbMenuItem);
	menu.add(rbMenuItem);
    
	// add the LDA->PCA1 option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(LDAPCA1);
	rbMenuItem.setFont(newFont);
	rbMenuItem.setEnabled(true);
	rbMenuItem.setSelected(false);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(LDAPCA1);
	group4.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the LDA->PCA2 option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(LDAPCA2);
	rbMenuItem.setFont(newFont);
	rbMenuItem.setEnabled(true);
	rbMenuItem.setSelected(false);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(LDAPCA2);
	group4.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the HLDA option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(HLDA);
	rbMenuItem.setFont(newFont);
	rbMenuItem.setEnabled(true);
	rbMenuItem.setSelected(false);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(HLDA);
	group4.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the ICA1 option to menu
	//
	//rbMenuItem = new JRadioButtonMenuItem(ICA1);
	//rbMenuItem.setFont(newFont);
	//rbMenuItem.setEnabled(false);
	//rbMenuItem.setSelected(false);
	//rbMenuItem.addActionListener(this);
	//rbMenuItem.setActionCommand(ICA1);
	//group4.add(rbMenuItem);
	//menu.add(rbMenuItem);

	// add the ICA2 option to menu
	//
	//rbMenuItem = new JRadioButtonMenuItem(ICA2);
	//rbMenuItem.setFont(newFont);
	//rbMenuItem.setEnabled(false);
	//rbMenuItem.setSelected(false);
	//rbMenuItem.addActionListener(this);
	//rbMenuItem.setActionCommand(ICA2);
	//group4.add(rbMenuItem);
	//menu.add(rbMenuItem);

	// add the SVM1 option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(SVM1);
	rbMenuItem.setFont(newFont);
	rbMenuItem.setEnabled(true);
	rbMenuItem.setSelected(false);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(SVM1);
	group4.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the SVM2 option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(SVM2);
	rbMenuItem.setFont(newFont);
	rbMenuItem.setEnabled(true);
	rbMenuItem.setSelected(false);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(SVM2);
	group4.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the menu seperator
	//
	menu.addSeparator();

	// add the LP option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(LP);
	rbMenuItem.setFont(newFont);
	rbMenuItem.setEnabled(true);
	rbMenuItem.setSelected(false);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(LP);
	group4.add(rbMenuItem);
	menu.add(rbMenuItem);
	
	// add the Kalman Filter option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(KF);
	rbMenuItem.setFont(newFont);
	rbMenuItem.setEnabled(true);
	rbMenuItem.setSelected(false);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(KF);
	group4.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the Unscented Kalman Filter option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(UKF);
	rbMenuItem.setFont(newFont);
	rbMenuItem.setEnabled(true);
	rbMenuItem.setSelected(true);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(UKF);
	group4.add(rbMenuItem);
	menu.add(rbMenuItem);

	// add the particle Filter option to menu
	//
	rbMenuItem = new JRadioButtonMenuItem(PF);
	rbMenuItem.setFont(newFont);
	rbMenuItem.setEnabled(true);
	rbMenuItem.setSelected(false);
	rbMenuItem.addActionListener(this);
	rbMenuItem.setActionCommand(PF);
	group4.add(rbMenuItem);
	menu.add(rbMenuItem);

	// build the Go menu
	//
	menu = new JMenu("Go");
	menu.setFont(newFont);
	menu.getAccessibleContext().setAccessibleDescription(initialize);
	menuBar.add(menu);

	// add the initialize option to menu
	//
	menuItem = new JMenuItem(initialize);
	menuItem.setFont(newFont);
	menuItem.setAccelerator(
	    KeyStroke.getKeyStroke(KeyEvent.VK_I, InputEvent.ALT_MASK));
	menuItem.addActionListener(this);
	menuItem.setActionCommand(initialize);
	menu.add(menuItem);

	// add the previous option to menu
	//
	prevMenuItem = new JMenuItem(previous);
	prevMenuItem.setFont(newFont);
	prevMenuItem.setAccelerator(
	     KeyStroke.getKeyStroke(KeyEvent.VK_UP, InputEvent.ALT_MASK));
	prevMenuItem.addActionListener(this);
	prevMenuItem.setActionCommand(previous);
	menu.add(prevMenuItem);

	// add the next option to menu
	//
	nextMenuItem = new JMenuItem(next);
	nextMenuItem.setFont(newFont);
	nextMenuItem.setAccelerator(
	    KeyStroke.getKeyStroke(KeyEvent.VK_DOWN, InputEvent.ALT_MASK));
	nextMenuItem.addActionListener(this);
	nextMenuItem.setActionCommand(next);
	menu.add(nextMenuItem);

	// build the Help menu
	//
	menu = new JMenu("Help");
	menu.setFont(newFont);
	menuBar.add(menu);

	// add the Release option to menu
	//
	menuItem = new JMenuItem("Release Notes");
	menuItem.setFont(newFont);
	menuItem.addActionListener(this);
	menuItem.setActionCommand(release);
	menu.add(menuItem);

	// add the Information option to menu
	//
	menuItem = new JMenuItem("Information and Support");
	menuItem.setFont(newFont);
	menuItem.addActionListener(this);
	menuItem.setActionCommand(info);
	menu.add(menuItem);

	menu.addSeparator();

	// add the Overview option to menu
	//
	menuItem = new JMenuItem("Applet Overview");
	menuItem.setFont(newFont);
	menuItem.addActionListener(this);
	menuItem.setActionCommand(overview);
	menu.add(menuItem);

	// add the Tutorial option to menu
	//
	menuItem = new JMenuItem("Applet Tutorial");
	menuItem.setFont(newFont);
	menuItem.addActionListener(this);
	menuItem.setActionCommand(tutorial);
	menu.add(menuItem);

	menu.addSeparator();

	// add the Plug-ins option to menu
	//
	menuItem = new JMenuItem("About Plug-ins");
	menuItem.setFont(newFont);
	menuItem.addActionListener(this);
	menuItem.setActionCommand(plugins);
	menu.add(menuItem);
    }

  // *********************************************************************
  //
  // declare class methods
  //
  // *********************************************************************

    /**
     * adds components to control panel
     *
     */
    public void add_components()
    {
	constrain( this, menuBar, 0, 0, GridBagConstraints.REMAINDER,
		   GridBagConstraints.REMAINDER, GridBagConstraints.BOTH,
		   GridBagConstraints.CENTER, 1, 1, 0, 0, 0, 0);
    }

    /**
     * method listens for actions taking place on text only menu items
     *
     * @param    e ActionEvent action command that is fired
     *
     */
    public void actionPerformed(ActionEvent e)
    {
	// get the source of the action that just occured
	String source = e.getActionCommand();
	
	// depending on the source of the event take the appropriate action
	if (source.equals(previous))
	{
	    // call the classifier
	    Algorithm algo = (Algorithm)Classify.getCurrAlgo();
	    Classify.initializeAlgo(algo);
	    algo.prevStep();
	} 
	else if (source.equals(next))
	{
	    Algorithm algo = (Algorithm)Classify.getCurrAlgo();
	    Classify.initializeAlgo(algo);
	    algo.nextStep();
	} 
	else if (source.equals(load))
	{} 
	else if (source.equals(save))
	{}
	else if (source.equals(initialize))
	{
	    // call the classifier
	    Algorithm algo = (Algorithm)Classify.getCurrAlgo();
	    Classify.initializeAlgo(algo);
	    algo.initialize();
	} 
	else if (source.equals(clearInput))
	{
	    Classify.input_points_d.initialize();
	    Classify.input_panel_d.clear();
	} 
	else if (source.equals(clearOutput))
	{
	    Classify.output_panel_d.clear();
	} 
	else if (source.equals(clearAll))
	{
	    Classify.input_points_d.initialize();
	    Classify.input_panel_d.clear();
	    Classify.output_panel_d.clear();
	    Classify.pro_box_d.clearMessage();
	} 
	else if (source.equals(clearPlots))
	{
	    Classify.input_points_d.initialize();
	    Classify.input_panel_d.clear();
	    Classify.output_panel_d.clear();
	} 
	else if (source.equals(clearTxt))
	{
	    Classify.pro_box_d.clearMessage();
	} 
	else if (source.equals(setgaus))
	{ 
	    
	    // reset data
	    //
	    setgausdlg.pack();
	    setgausdlg.setVisible(true);	
	    
	}
	else if (source.equals(set_trn))
	{
	    settrnFrame.pack();
	    settrnFrame.setVisible(true);
	}
	else if (source.equals(set_obs))
	{
	    setobsFrame.pack();
	    setobsFrame.setVisible(true);
	}
	else if (source.equals(set_covar_nse_pro))
	{
	    setcovar_nse_proFrame.pack();
	    setcovar_nse_proFrame.setVisible(true);
	}
	else if (source.equals(set_covar_nse_obs))
	{
	    setcovar_nse_obsFrame.pack();
	    setcovar_nse_obsFrame.setVisible(true);
	}
	else if (source.equals(setccolors))
	{
	    paneldset1.setBackground(Classify.input_points_d.color_dset1);
	    paneldset2.setBackground(Classify.input_points_d.color_dset2);
	    paneldset3.setBackground(Classify.input_points_d.color_dset3);
	    paneldset4.setBackground(Classify.input_points_d.color_dset4);
	    setccolorsdlg.pack();
	    setccolorsdlg.setVisible(true);
	}
	else if (source.equals(setalgoparams)) {

	    if (Classify.algo_index_d == Classify.algo_index_kmeans_d) {
		kmeansparamlbl.setText("K-Means Parameters");
		applykmeansparamsbttn.setText("Apply K-Means Parameters");
		setkmeansdlg.pack();
		setkmeansdlg.setVisible(true);
	    }
	    else if (Classify.algo_index_d == Classify.algo_index_lbg_d) {
		kmeansparamlbl.setText("LBG Parameters");
		applykmeansparamsbttn.setText("Apply LBG Parameters");
		setkmeansdlg.pack();
		setkmeansdlg.setVisible(true);
	    }
	    else if (Classify.algo_index_d == Classify.algo_index_hlda_d) {
		sethldadlg.pack();
		sethldadlg.setVisible(true);
	    }
	    else if (Classify.algo_index_d == Classify.algo_index_lp_d) {
		setlpdlg.pack();
		setlpdlg.setVisible(true);
	    }
	    else if (Classify.algo_index_d == Classify.algo_index_kf_d) {
		kfparamlbl.setText("Kalman Filter Parameters");
		applykfparamsbttn.setText("Apply Kalman Filter Parameters");
		particles_label.setVisible(false);
		particlesField.setVisible(false);
		alphaLabel.setVisible(false);
		alphaField.setVisible(false);
		betaLabel.setVisible(false);
		betaField.setVisible(false);
		kappaLabel.setVisible(false);
		kappaField.setVisible(false);
		setkfdlg.pack();
		setkfdlg.setVisible(true);
	    }
	    else if (Classify.algo_index_d == Classify.algo_index_ukf_d) {
		kfparamlbl.setText("UKF Parameters");
		applykfparamsbttn.setText("Apply UKF Parameters");
		particles_label.setVisible(false);
		particlesField.setVisible(false);
		alphaLabel.setVisible(true);
		alphaField.setVisible(true);
		betaLabel.setVisible(true);
		betaField.setVisible(true);
		kappaLabel.setVisible(true);
		kappaField.setVisible(true);
		setkfdlg.pack();
		setkfdlg.setVisible(true);
	    }
	    else if (Classify.algo_index_d == Classify.algo_index_pf_d) {
		kfparamlbl.setText("Particle Filter Parameters");
		applykfparamsbttn.setText("Apply Particle Filter Parameters");
		particles_label.setVisible(true);
		particlesField.setVisible(true);
		alphaLabel.setVisible(false);
		alphaField.setVisible(false);
		betaLabel.setVisible(false);
		betaField.setVisible(false);
		kappaLabel.setVisible(false);
		kappaField.setVisible(false);
		setkfdlg.pack();
		setkfdlg.setVisible(true);
	    }
	}
	else if (source.equals(changeset1))
	{
	    Color newColor = JColorChooser.showDialog(
					  setccolorsdlg, 
					  "Class 0 Color",
					  Classify.input_points_d.color_dset1);
	    
	    if (newColor == null)
		newColor = Classify.input_points_d.color_dset1;

	    Classify.input_points_d.setColors(
					  newColor,
					  Classify.input_points_d.color_dset2,
					  Classify.input_points_d.color_dset3,
					  Classify.input_points_d.color_dset4);

	    paneldset1.setBackground(newColor);
	}
	else if (source.equals(changeset2))
	{	
	    
	    Color newColor = JColorChooser.showDialog(
					  setccolorsdlg, 
					  "Class 1 Color",
					  Classify.input_points_d.color_dset2);

	    if (newColor == null)
		newColor = Classify.input_points_d.color_dset2;
	    
	    Classify.input_points_d.setColors(
					  Classify.input_points_d.color_dset1,
					  newColor,
					  Classify.input_points_d.color_dset3,
					  Classify.input_points_d.color_dset4);
 
	    paneldset2.setBackground(newColor);
	}
	else if (source.equals(changeset3))
	{
	    Color newColor = JColorChooser.showDialog(
					setccolorsdlg, 
					"Class 2 Color",
					Classify.input_points_d.color_dset3);

	    if (newColor == null)
		newColor = Classify.input_points_d.color_dset3;
	    
	    Classify.input_points_d.setColors(
					  Classify.input_points_d.color_dset1,
					  Classify.input_points_d.color_dset2,
					  newColor,
					  Classify.input_points_d.color_dset4);

	    paneldset3.setBackground(newColor);
	}
	else if (source.equals(changeset4))
	{
	    
	    Color newColor = JColorChooser.showDialog(
					setccolorsdlg, 
					"Class 3 Color",
					Classify.input_points_d.color_dset4);
	    
	    if (newColor == null)
		newColor = Classify.input_points_d.color_dset4;
	    
	    Classify.input_points_d.setColors(
					  Classify.input_points_d.color_dset1,
					  Classify.input_points_d.color_dset2,
					  Classify.input_points_d.color_dset3,
					  newColor);

	    paneldset4.setBackground(newColor);
	}
	// Set the draw points flag
	else if (source.equals(drwpts))
        {
	    drwptsf = true;
	    drwgaussf = false;
	}
	// Set the draw cluster flag
	else if (source.equals(drwgauss))
        {
	    drwptsf = false;
	    drwgaussf = true;
        }
	else if (source.equals(zoomin))
        {
	    zoomi = true;
	    zoomo = false;
        }   
	else if (source.equals(zoomout))
	{
	    zoomo = true;
	    zoomi = false;
	}
	else if (source.equals(twoGaussian))
	{
	    // reset data
	    Classify.input_points_d.initialize();
	    Classify.input_points_d.setTwoGaussian(
		 Classify.input_panel_d.selection_area_d.getDisplayScale());
	    Classify.input_panel_d.repaint();
	} 
	else if (source.equals(fourGaussian))
	{
	    // reset data
	    Classify.input_points_d.initialize();
	    Classify.input_points_d.setFourGaussian(
		 Classify.input_panel_d.selection_area_d.getDisplayScale());
	    Classify.input_panel_d.repaint();
	} 
	else if (source.equals(overGaussian))
	{
	    // reset data
	    Classify.input_points_d.initialize();
	    Classify.input_points_d.setOverGaussian(
		 Classify.input_panel_d.selection_area_d.getDisplayScale());
	    Classify.input_panel_d.repaint();
	} 
	else if (source.equals(twoEllipses))
	{
	    // reset data
	    Classify.input_points_d.initialize();
	    Classify.input_points_d.setTwoEllipses(
		 Classify.input_panel_d.selection_area_d.getDisplayScale());
	    Classify.input_panel_d.repaint();
	} 
	else if (source.equals(fourEllipses))
	{
	    // reset data
	    Classify.input_points_d.initialize();
	    Classify.input_points_d.setFourEllipses(
		 Classify.input_panel_d.selection_area_d.getDisplayScale());
	    Classify.input_panel_d.repaint();
	} 
	else if (source.equals(rotatedEllipses))
	{
	    // reset data
	    Classify.input_points_d.initialize();
	    Classify.input_points_d.setRotatedEllipses(
		 Classify.input_panel_d.selection_area_d.getDisplayScale());
	    Classify.input_panel_d.repaint();
	} 
	else if (source.equals(toroidal))
	{
	    // reset data
	    Classify.input_points_d.initialize();
	    Classify.input_points_d.setToroidal(
		 Classify.input_panel_d.selection_area_d.getDisplayScale());
	    Classify.input_panel_d.repaint();
	} 
	else if (source.equals(yinYang))
	{
	    // reset data
	    Classify.input_points_d.initialize();
	    Classify.input_points_d.setYinYang(
		 Classify.input_panel_d.selection_area_d.getDisplayScale());
	    Classify.input_panel_d.repaint();
	} 
	else if (source.equals(randomSignal))
	{
	    // reset data
	    Classify.input_points_d.initialize();
	    Classify.input_points_d.setRandomSignal(
		 Classify.input_panel_d.selection_area_d.getDisplayScale());
	    Classify.input_panel_d.repaint();
	} 
	else if (source.equals(lorentzSignal))
	{
	    // reset data
	    Classify.input_points_d.initialize();
	    Classify.input_points_d.setLorentzSignal(
		 Classify.input_panel_d.selection_area_d.getDisplayScale());
	    Classify.input_panel_d.repaint();
	} 
	else if (source.equals(class1))
	{
	    // set the data source
	    Classify.input_points_d.set_index_d = 1;
	} 
	else if (source.equals(class2))
	{
	    // set the data source
	    Classify.input_points_d.set_index_d = 2;
	}     
	else if (source.equals(class3))
	{
	    // set the data source
	    Classify.input_points_d.set_index_d = 3;
	} 
	else if (source.equals(class4))
	{
	    // set the data source
	    Classify.input_points_d.set_index_d = 4;
	} 
	else if (source.equals(kmeans))
	{
	    algoParamMenuItem.setEnabled(true);
	    Classify.algo_index_d = Classify.algo_index_kmeans_d;
	    Classify.pro_box_d.appendMessage(
                               "\nSwitching to K-Means Clustering");
	} 
	else if (source.equals(binary))
	{
	    algoParamMenuItem.setEnabled(true);
	    Classify.algo_index_d = Classify.algo_index_lbg_d;
	    Classify.pro_box_d.appendMessage(
                               "\nSwitching  to LBG Clustering");
	} 
	else if (source.equals(euclidean))
	{
	    algoParamMenuItem.setEnabled(false);
	    Classify.algo_index_d = Classify.algo_index_ed_d;
	    Classify.pro_box_d.appendMessage(
                               "\nSwitching to Euclidean Distance");
	} 
	else if (source.equals(nearest))
	{
	    algoParamMenuItem.setEnabled(false);
	    Classify.algo_index_d = Classify.algo_index_nn_d;
	    Classify.pro_box_d.appendMessage(
                               "\nSwitching to Nearest Neighbor");
	} 
	else if (source.equals(PCA1))
	{
	    algoParamMenuItem.setEnabled(false);
	    Classify.algo_index_d = Classify.algo_index_pcaci_d;
	    Classify.pro_box_d.appendMessage(
			       "\nSwitching to Class Independent PCA");
	} 
	else if (source.equals(PCA2))
	{
	    algoParamMenuItem.setEnabled(false);
	    Classify.algo_index_d = Classify.algo_index_pca2_d;
	    Classify.pro_box_d.appendMessage(
                               "\nSwitching to Class Dependent PCA");
	} 
	else if (source.equals(LDA1))
	{
	    algoParamMenuItem.setEnabled(false);
	    Classify.algo_index_d = Classify.algo_index_ldaci_d;
	    Classify.pro_box_d.appendMessage(
			       "\nSwitching to Class Independent LDA");
	} 
	else if (source.equals(LDA2))
	{
	    algoParamMenuItem.setEnabled(false);
	    Classify.algo_index_d = Classify.algo_index_lda2_d;
	    Classify.pro_box_d.appendMessage(
			       "\nSwitching to Class Dependent LDA");
	} 
	else if (source.equals(LDAPCA1))
	{
	    algoParamMenuItem.setEnabled(false);
	    Classify.algo_index_d = Classify.algo_index_ldapca1_d;
	    Classify.pro_box_d.appendMessage(
                               "\nSwitching to Independent LDA->PCA");
	}
	else if (source.equals(HLDA))
	{
	    algoParamMenuItem.setEnabled(true);
	    Classify.algo_index_d = Classify.algo_index_hlda_d;
	    Classify.pro_box_d.appendMessage(
			       "\nSwitching to HLDA");
	}

//      else if (source.equals(LDAPCA2))
//      {
    //        Classify.algo_index_d = Classify.algo_index_ldapca2_d;
    //        Classify.pro_box_d.appendMessage(
    //  	"\nSwitching to Dependent LDA->PCA");
//      }
	else if (source.equals(LP))
	{
	    algoParamMenuItem.setEnabled(true);
	    Classify.algo_index_d = Classify.algo_index_lp_d;
	    Classify.pro_box_d.appendMessage(
                               "\nSwitching to Linear Prediction");
	}
	else if (source.equals(KF))
	{
	    algoParamMenuItem.setEnabled(true);
	    Classify.algo_index_d = Classify.algo_index_kf_d;
	    Classify.pro_box_d.appendMessage(
                               "\nSwitching to Kalman Filtering");
	}
	else if (source.equals(UKF))
	{
	    algoParamMenuItem.setEnabled(true);
	    Classify.algo_index_d = Classify.algo_index_ukf_d;
	    Classify.pro_box_d.appendMessage(
                               "\nSwitching to Unscented Kalman Filtering");
	}
	else if (source.equals(PF))
	{
	    algoParamMenuItem.setEnabled(true);
	    Classify.algo_index_d = Classify.algo_index_pf_d;
	    Classify.pro_box_d.appendMessage(
                               "\nSwitching to Particle Filtering");
	}
	else if (source.equals(ICA1))
	{} 
	else if (source.equals(ICA2))
	{} 
	else if (source.equals(SVM1))
	{
	    algoParamMenuItem.setEnabled(false);
	    Classify.algo_index_d = Classify.algo_index_svm_d;
	    Classify.pro_box_d.appendMessage("\nSwitching to SVM");
	} 
	else if (source.equals(SVM2))
	{
	    algoParamMenuItem.setEnabled(false);
	    Classify.algo_index_d = Classify.algo_index_rvm_d;
	    Classify.pro_box_d.appendMessage("\nSwitching to RVM");
	} 
	else if (source.equals(limit))
	{
	    // display the text area and dismiss button
	    scale.pack();
	    scale.setVisible(true);
	} 
	else if (source.equals(release))
	{
	    // clear the text in the text area
	    //
	    textArea.setText("");
	    
	    // read the help file contents and append them to text area
	    try
	    {
		// get the URL component
		url = (URL)urlvec.elementAt(0);
		
		// open a file descriptor to read the help file
		InputStreamReader rd = new InputStreamReader(url.openStream());
		
		// initialize the buffer to read the contents of the help file
		buff = new BufferedReader(rd);
		
		// read each line fo the file
		while ((document = buff.readLine()) != null)
		{
		    // add the help message line to text area
		    textArea.append(document + newline);
		}
	    } 
	    catch (IOException ioe)
	    {}
	    
	    // display the text area and dismiss button
	    frame.pack();
	    frame.setVisible(true);
	} 
	else if (source.equals(info))
	{
	    // clear the text in the text area
	    textArea.setText("");
	    
	    // read the help file contents and append them to text area
	    try
	    {
		// get the URL component
		url = (URL)urlvec.elementAt(1);
		
		// open a file descriptor to read the help file
		InputStreamReader rd = new InputStreamReader(url.openStream());
		
		// initialize the buffer to read the contents of the help file
		buff = new BufferedReader(rd);
		
		// read each line fo the file
		while ((document = buff.readLine()) != null)
		{
		    // add the help message line to text area
		    textArea.append(document + newline);
		}
	    } 
	    catch (IOException ioe)
	    {}
	    
	    // display the text area and dismiss button
	    frame.pack();
	    frame.setVisible(true);   
	} 
	else if (source.equals(overview))
	{
	    // clear the text in the text area
	    textArea.setText("");
	    
	    // read the help file contents and append them to text area
	    try
	    {
		// get the URL component
		url = (URL)urlvec.elementAt(2);
		
		// open a file descriptor to read the help file
		InputStreamReader rd = new InputStreamReader(url.openStream());
		
		// initialize the buffer to read the contents of the help file
		buff = new BufferedReader(rd);
		
		// read each line fo the file
		while ((document = buff.readLine()) != null)
		{
		    // add the help message line to text area
		    textArea.append(document + newline);
		}
	    } 
	    catch (IOException ioe)
	    {}
	    
	    // display the text area and dismiss button
	    frame.pack();
	    frame.setVisible(true);	    
	} 
	else if (source.equals(tutorial)) {

	    // display the document
	    //
	    try { 

		// get the URL component
		//
		url = (URL)urlvec.elementAt(3);

		// display the url on a seperate browser
		//
		//context.showDocument(url, "_blank");
		context.showDocument(url);
	    } 
	    catch(Exception ae) { }

	}
	else if (source.equals(plugins)) {
	    // clear the text in the text area
	    textArea.setText("");
	    
	    // read the help file contents and append them to text area
	    try
	    {
		// get the URL component
		url = (URL)urlvec.elementAt(4);
		
		// open a file descriptor to read the help file
		InputStreamReader rd = new InputStreamReader(url.openStream());
		
		// initialize the buffer to read the contents of the help file
		buff = new BufferedReader(rd);
		
		// read each line fo the file
		while ((document = buff.readLine()) != null)
		{
		    // add the help message line to text area
		    textArea.append(document + newline);
		}
	    } 
	    catch (IOException ioe)
	    {}
	    // display the text area and dismiss button
	    frame.pack();
	    frame.setVisible(true);
	} 
	else if (source.equals(done))
	{
	    // remove the frame form the screen
	    frame.setVisible(false);
	    setccolorsdlg.setVisible(false);	
	} 
	else if (source.equals(destroy))
	{
	    // remove the frame form the screen
	    setgausdlg.setVisible(false);
	} 
	else if (source.equals(saveiterations))
	{
	    // remove the frame form the screen
	    iterpara.setVisible(false);
	    

	} 
	else if (source.equals(applykmeansparamslbl)) {
	    setkmeansdlg.setVisible(false);
	    try
	    {
		iterations = Integer.valueOf(
                                    kmeansIterFld.getText()).intValue();
	    } 
	    catch (java.lang.NumberFormatException event)
	    {
		iterations = 10;
	    }
	    // make sure that the maximum number of clusters is valid
	    if (iterations < 0)
	    {
		iterations = 10;
	    }

	    try
	    {
		clusters = Integer.valueOf(
                                    kmeansClustersFld.getText()).intValue();
	    } 
	    catch (java.lang.NumberFormatException event)
	    {
		clusters = 8;
	    }
	    // make sure that the maximum number of clusters is valid
	    if (clusters > 8 || clusters < 0)
	    {
		iterations = 8;
	    }
	}
	else if (source.equals(applylbgparamslbl)) {
	    setlbgdlg.setVisible(false);
	}
	else if (source.equals(applyhldaparamslbl)) {
	    sethldadlg.setVisible(false);

	    try
	    {
		//covtype = Integer.valueOf(covtypeField.getText()).intValue();
		if (equalRadioButton.isSelected()) {
		    covtype = 1;
		}
		else if (diagonalRadioButton.isSelected()) {
		    covtype = 2;
		}
		else if (unequalRadioButton.isSelected()) {
		    covtype = 3;
		}
	    }
	    catch (java.lang.NumberFormatException event)
	    {
		covtype = 1;
	    }
	    
	    try
	    {
		//hlda_initype = Integer.valueOf(hlda_initypeField.getText()).intValue();
		if (ldaRadioButton.isSelected()) {
		    hlda_initype = 1;
		}
		else if (identityRadioButton.isSelected()) {
		    hlda_initype = 2;
		}
	    }
	    catch (java.lang.NumberFormatException event)
	    {
		hlda_initype = 1;
	    }
	    
	}
	else if (source.equals(applylpparamslbl)) {
	    setlpdlg.setVisible(false);

	    try
	    {
		lporder = Integer.valueOf(lporderField.getText()).intValue();
	    }
	    catch (java.lang.NumberFormatException event)
	    {
		lporder = 3;
	    }
	    	    
	    try
	    {
		iporder = Integer.valueOf(iporderField.getText()).intValue();
	    }
	    catch (java.lang.NumberFormatException event)
	    {
		iporder = 50;
	    }

	}
	else if (source.equals(applykfparamslbl)) {
	    setkfdlg.setVisible(false);

	    	    try
	    {
		obs = Double.valueOf(obsField.getText()).doubleValue();
	    }
	    catch (java.lang.NumberFormatException event)
	    {
		obs = 1.0;
	    }

	    try
	    {
		trn = Double.valueOf(trnField.getText()).doubleValue();
	    }
	    catch (java.lang.NumberFormatException event)
	    {
		trn = 1.5;
	    }

	    try
	    {
		covar_nse_pro = Double.valueOf(covar_nse_proField.getText()).doubleValue();
	    }
	    catch (java.lang.NumberFormatException event)
	    {
		covar_nse_pro = 1.0;
	    }
	    try
	    {
		covar_nse_obs = Double.valueOf(covar_nse_obsField.getText()).doubleValue();
	    }
	    catch (java.lang.NumberFormatException event)
	    {
		covar_nse_obs = 0.1;
		System.out.println("meas noise error");
	    }
	    try
	    {
		covar_nse_err = Double.valueOf(covar_nse_errField.getText()).doubleValue();
	    }
	    catch (java.lang.NumberFormatException event)
	    {
		covar_nse_err = 0.1;
		System.out.println("estimate error covariance");
	    }

	    if (Classify.algo_index_d == Classify.algo_index_ukf_d) {

		try
		{
		    alpha = Double.valueOf(alphaField.getText()).intValue();
		}
		catch (java.lang.NumberFormatException event)
		{
		    alpha = -1.0;
		}
			
			    
		try
		{
		    beta = Double.valueOf(betaField.getText()).intValue();
		}
		catch (java.lang.NumberFormatException event)
		{
		    beta = -1.0;
		}
		try
		{
		    kappa = Double.valueOf(kappaField.getText()).intValue();
		}
		catch (java.lang.NumberFormatException event)
		{
		    kappa = -1.0;
		}		
	    }
	    else if (Classify.algo_index_d == Classify.algo_index_pf_d) {
		try
		{
		    particles = Integer.valueOf(particlesField.getText()).intValue();
		}
		catch (java.lang.NumberFormatException event)
		{
		    particles = 50;
		}
	    } 	
	}
	else if (source.equals(save_obs))
	{
	    // remove the frame form the screen
	    //
	    setobsFrame.setVisible(false);
	    

	} 
	else if (source.equals(save_trn))
	{
	    // remove the frame form the screen
	    //
	    settrnFrame.setVisible(false);
	    
	} 
	else if (source.equals(save_covar_nse_pro))
	{
	    // remove the frame form the screen
	} 
	else if (source.equals(save_covar_nse_obs))
	{
	    // remove the frame form the screen
	    //
	    setcovar_nse_obsFrame.setVisible(false);
	    

	} 
	else if (source.equals(save_covar_nse_err))
	{
	    // remove the frame form the screen
	    //
	    setcovar_nse_errFrame.setVisible(false);
	    

	} 
	else if (source.equals(savealpha))
	{
	    // remove the frame form the screen
	    //
	    setalphaFrame.setVisible(false);
	    

	} 
	else if (source.equals(savebeta))
	{
	    // remove the frame form the screen
	    //
	    setbetaFrame.setVisible(false);

	} 
	else if (source.equals(savekappa))
	{
	    // remove the frame form the screen
	    //
	    setkappaFrame.setVisible(false);
	    

	} 
	else if (source.equals(apply))
	{
	    try 
	    {
		points = Integer.valueOf(pointsField.getText()).intValue();
		if(points <= 5)
		    points = 6;
	    }
	    catch (java.lang.NumberFormatException event) 
	    {
		points = 200;
	    }
	    try 
	    {
		cov11 = Double.valueOf(cov11Field.getText()).doubleValue();
	    }
	    catch (java.lang.NumberFormatException event) 
	    {
		cov11 = 1.0;
	    }
	    try 
	    {
		cov12 = Double.valueOf(cov12Field.getText()).doubleValue();
	    }
	    catch (java.lang.NumberFormatException event) 
	    {
		cov12 = 0.0;
	    }
	    try 
	    {
		cov21 = Double.valueOf(cov21Field.getText()).doubleValue();
	    }
	    catch (java.lang.NumberFormatException event) 
	    {
		cov21 = 0.0;
	    }
	    try 
	    {
		cov22 = Double.valueOf(cov22Field.getText()).doubleValue();
	    }
	    catch (java.lang.NumberFormatException event) 
	    {
		cov22 = 1.0;
	    }
	    
	    Classify.input_points_d.setDrawGaussValues(points, 
						       cov11, cov12,
						       cov21, cov22);
	    setgausdlg.setVisible(false);
	    Classify.input_panel_d.repaint();
	} 
	else if (source.equals(refresh))
	{
	    // declare local variables
	    //
	    double xmin = 0.0;
	    double xmax = 0.0;
	    double ymin = 0.0;
	    double ymax = 0.0;
	    
	    // remove the frame form the screen
	    //
	    scale.setVisible(false);
	    
	    try 
	    {
		xmin = Double.valueOf(xMinField.getText()).doubleValue();
	    }
	    catch (java.lang.NumberFormatException event) 
	    {
		xmin = -2.0;
	    }
	    try 
	    {
		xmax = Double.valueOf(xMaxField.getText()).doubleValue();
	    }
	    catch (java.lang.NumberFormatException event) 
	    {
		xmax = 2.0;
	    }
	    try 
	    {
		ymin = Double.valueOf(yMinField.getText()).doubleValue();
	    }
	    catch (java.lang.NumberFormatException event) 
	    {
		ymin = -2.0;
	    }
	    try 
	    {
		ymax = Double.valueOf(yMaxField.getText()).doubleValue();
	    }
	    catch (java.lang.NumberFormatException event) 
	    {
		ymax = 2.0;
	    }
	    
	    // update the datapoints scale
	    //
	    Classify.input_panel_d.selection_area_d.setDisplayScale(new 
		DisplayScale(xmax, xmin, ymax, ymin));
	    Classify.output_panel_d.disp_area_d.setDisplayScale(new 
		DisplayScale(xmax, xmin, ymax, ymin));
	    Classify.output_panel_d.refresh();
	    Classify.input_panel_d.refresh();
	}
    }

}
